local function sendShockTrail(source_position, target_position)
    local TRAIL_EFFECT = Idstring("effects/payday2/particles/character/taser_thread_mx")
    local idstr_trail = Idstring("trail")
    local idstr_simulator_length = Idstring("simulator_length")
    local idstr_size = Idstring("size")
    local trail_length
    
    local hit_position = target_position
    -- local hit_position = self._unit:position() --
    local distance_from_target = mvector3.distance_sq(source_position, hit_position)
    if not trail_length then
        trail_length = World:effect_manager():get_initial_simulator_var_vector2(TRAIL_EFFECT, idstr_trail, idstr_simulator_length, idstr_size)
    end
    
    -- local rot = Rotation()
    -- mrotation.set_look_at(rot, source_position - hit_position, math.UP)
    local trail = World:effect_manager():spawn({
        effect = Idstring("effects/payday2/particles/character/taser_thread_mx"),
        position = source_position,
        normal =  hit_position - source_position,
        -- rotation = rot -- Solved using custom effect
    })

    mvector3.set_y(trail_length, math.sqrt(distance_from_target))
    World:effect_manager():set_simulator_var_vector2(trail, idstr_trail, idstr_simulator_length, idstr_size, trail_length)
end

Hooks:PostHook(ArrowBase, "set_weapon_unit", "HAWKEYE_ArrowBase_set_weapon_unit", function(self, weapon_unit)
    if weapon_unit  then
        self._overcharged_shot = weapon_unit:base()._overcharged_shot
    end
end)

Hooks:PostHook(ArrowBase, "_on_collision", "HAWKEYE_ArrowBase_on_collision", function(self, col_ray)
    local loose_shoot = self._weapon_charge_fail
    if not loose_shoot and alive(col_ray.unit) and self._overcharged_shot then
        
        -- Mini Explosion for style and stun
        InstantExplosiveBulletBase:on_collision(col_ray, self._weapon_unit, managers.player:player_unit(), 5, false)
        -- managers.explosion:explode_on_client(col_ray.position, col_ray.normal, managers.player:player_unit(), 1, 500, 1)

        local SLOT_MASK = managers.slot:get_mask("enemies")
		local user_unit = managers.player:player_unit()
		local tweak_damage = 20	
		local tweak_range = 400	

		local bodies = World:find_units_quick("sphere", col_ray.position, tweak_range, SLOT_MASK)
		local action_data = {
			damage_effect = 2,
            name_id = 'zeus',
            attacker_unit = managers.player:player_unit(), -- or nil
            col_ray = col_ray,
            damage = tweak_damage,
            variant = "taser_tased"
		}
		for _, hit_unit in ipairs(bodies) do
			if hit_unit:character_damage() then
                sendShockTrail(hit_unit:movement():m_head_pos(), col_ray.position)
				hit_unit:character_damage():damage_melee(action_data)
			end
		end
        
        -- local player_pos = Vector3() 
        -- mvector3.set(player_pos, managers.player:equipped_weapon_unit():position())
        -- sendShockTrail(player_pos, col_ray.position)
        
        -- Thank you Krimzin
        local object = managers.player:equipped_weapon_unit():get_object(Idstring("a_m"))
        local player_pos = object:position() + (object:rotation():y() * 20.3)
        sendShockTrail(player_pos, col_ray.position)

        -- Shock effect on hit location if not NPC floor or wall or celing or etc etc, you got the point
        -- it's rotated toward the player cause the effect is cool as Fuck the when the arrow is stuck in the floor or a wall
        local hit_unit = col_ray.unit
        if not hit_unit.damage or not hit_unit:damage() then
            local rot = Rotation()
            mrotation.set_look_at(rot, player_pos - col_ray.position, math.UP)
            World:effect_manager():spawn({
                effect = Idstring("effects/payday2/particles/character/taser_thread"),
                position = col_ray.position,
                normal =  col_ray.position - player_pos,
                rotation = rot
            })
        end
    end
end)

-- PLayer feet managers.player:player_unit():position()) 
-- Player Head managers.player:player_unit():movement():m_head_pos())