HUDOVERCHARGECounter = HUDOVERCHARGECounter or class()

function HUDOVERCHARGECounter:init(hud)
    self._hud_panel = hud.panel
    self._overcharge_panel = self._hud_panel:panel({
        name = "overcharge_counter_panel",
        visible = false,
        w = 200,
        h = 200
    })

    self._overcharge_panel:set_top(50)
    self._overcharge_panel:set_right(self._hud_panel:w() + 11)

    local overcharge_box = HUDBGBox_create(self._overcharge_panel, { w = 38, h = 38, },  {})

    self._text = overcharge_box:text({
        name = "text",
        text = "0",
        valign = "center",
        align = "center",
        vertical = "center",
        w = overcharge_box:w(),
        h = overcharge_box:h(),
        layer = 1,
        color = Color.white,
        font = tweak_data.hud_corner.assault_font,
        font_size = tweak_data.hud_corner.numhostages_size * 0.9
    })

    local overcharge_icon = self._overcharge_panel:bitmap({
        name = "overcharge_icon",
        texture = "icons_atlas_mx",
        texture_rect = { 4 * 80, 2 * 80, 80, 80 },
        valign = "top",
        color = Color.white,
        layer = 1,
        w = overcharge_box:w(),
        h = overcharge_box:h()	
    })
    overcharge_icon:set_right(overcharge_box:parent():w() - 10)
    overcharge_icon:set_center_y(overcharge_box:h() / 2)
    overcharge_box:set_right(overcharge_icon:left())

    self._cooldown_duration = 0
end

function HUDOVERCHARGECounter:update(t)
    self._cooldown_duration = t
    self._overcharge_panel:set_visible(managers.player:has_category_upgrade("bow", "overcharge"))
    if self._cooldown_duration > 0 then
        self._text:set_text(string.format("%.fs", self._cooldown_duration))
    else 
        self._text:set_text("Ready")
    end
    self._text:set_color(Color.white)
end

local _setup_player_info_hud_pd2_original = HUDManager._setup_player_info_hud_pd2
function HUDManager:_setup_player_info_hud_pd2(...)
    _setup_player_info_hud_pd2_original(self, ...)
    self._hud_overcharge_counter = HUDOVERCHARGECounter:new(managers.hud:script(PlayerBase.PLAYER_INFO_HUD_PD2))
end

function HUDManager:set_cooldown_overcharge(t)
    self._hud_overcharge_counter._battery_life = t
end

function HUDManager:update_overcharge(t, dt)
    self._hud_overcharge_counter:update(t)
end

function HUDManager:update_overcharge_icons(jam_pagers)
    self._hud_overcharge_counter:update_icons(jam_pagers)
end

Hooks:Add("SF_Cooldowns_update", "HAWKEYE_Cooldowns", function(p_manager, t, dt)
    local cd = p_manager:get_ability_remaining_cooldown("HAWKEYE_Overcharge") 
    if managers and managers.hud then
        managers.hud:update_overcharge(cd)
    end
end)