-- This function allows to use the RELOAD BUTTON to interrupt the bow charging
-- The_Punisher I fucking love you mate
local Hawkeye_PlayerStandard_check_action_reload = PlayerStandard._check_action_reload
function PlayerStandard:_check_action_reload(t, input)
	local action_wanted = input.btn_reload_press
	if action_wanted then
		-- Using self._state_data.charging_weapon as an alternative to _is_charging_weapon() since it's modified to work with run and gunrr
		if self._state_data.charging_weapon and self._equipped_unit then
			local weapon = self._equipped_unit:base()
			if weapon then
				weapon:interupt_charging()
				return
			end
		end
	end
	return Hawkeye_PlayerStandard_check_action_reload(self, t, input)
end

local Hawkeye_PlayerStandard_start_action_reload = PlayerStandard._start_action_reload
function PlayerStandard:_start_action_reload(t)
	local weapon = self._equipped_unit:base()

	if weapon and weapon and weapon:can_reload() and weapon._bow_multishot_overload then
		weapon:tweak_data_anim_stop("fire")

		local speed_multiplier = weapon:reload_speed_multiplier()
		local empty_reload = weapon:clip_empty() and 1 or 0

		if weapon._use_shotgun_reload then
			empty_reload = weapon:get_ammo_max_per_clip() - weapon:get_ammo_remaining_in_clip()
		end

		local tweak_data = weapon:weapon_tweak_data()
		local reload_anim = "reload"
		local reload_prefix = weapon:reload_prefix() or ""
		local reload_name_id = tweak_data.animations.reload_name_id or weapon.name_id

		if weapon:clip_empty() or weapon._bow_multishot_overload then
			local reload_ids = Idstring(reload_prefix .. "reload_" .. reload_name_id)
			local result = self._ext_camera:play_redirect(reload_ids, speed_multiplier)

			Application:trace("PlayerStandard:_start_action_reload( t ): ", reload_ids)

			self._state_data.reload_expire_t = t + (tweak_data.timers.reload_empty or weapon:reload_expire_t() or 2.6) / speed_multiplier
		end

		weapon:start_reload()

		if not weapon:tweak_data_anim_play(reload_anim, speed_multiplier) then
			weapon:tweak_data_anim_play("reload", speed_multiplier)
			Application:trace("PlayerStandard:_start_action_reload( t ): ", reload_anim)
		end

		self._ext_network:send("reload_weapon", empty_reload, speed_multiplier)
	else
		Hawkeye_PlayerStandard_start_action_reload(self, t)
	end
end

-- This Fixes not being able to start the sprint while charging the bow
function PlayerStandard:_is_charging_weapon()
	local player_run_and_shoot = managers.player:has_category_upgrade("player", "run_and_shoot")
	local bow_run_and_shoot = managers.player:has_category_upgrade("bow", "hip_run_and_shoot")
	local ignore_charging = player_run_and_shoot or bow_run_and_shoot
	if ignore_charging then
		return false
	else
		return self._state_data.charging_weapon
	end
end