local skilltree_name = "mx_pack"

Hooks:Add("SF_InfamyTweakDataPostInit", "SF_InfamyTweakDataPostInit_Hawkeye", function(infamy)
    infamy:add_skill_tree(skilltree_name)
end)

Hooks:PostHook(SkillTreeTweakData, "init", "Hawkeye_SkillTreeTweakData_init", function(self)
	self:add_skill_tree(skilltree_name)

	local hawkeye_tiers = {
		{
			"swift_hands"
		},
		{
			"piercing_strike",
			"old_style_marksman"
		},
		{
			"huntsman", -- CHC
			"overcharge" -- Bow goes BRRRRRRRRRR
		},
		{
			"bow_multishot_overload"
		}
	}
	
	local custom_icons_texture = "icons_atlas_mx"

	self:add_sub_skill_tree(skilltree_name, "mx_hawkeye", hawkeye_tiers)

	-- Tier 1
	local swift_hands_T1 = {"bow_swap_speed_multiplier_1", "bow_hip_run_and_shoot"}
	self:add_new_skill("swift_hands", swift_hands_T1 , "bow_swap_speed_multiplier_2", 1, {7, 1}, custom_icons_texture)

	-- Tier 2
	local piercing_strike_T1 = {"bow_charge_speed_multiplier_1", "bow_armor_piercing_1"}
	local piercing_strike_T2 = {"bow_charge_speed_multiplier_2", "bow_armor_piercing_2"}
	self:add_new_skill("piercing_strike", piercing_strike_T1, piercing_strike_T2 , 2, { 7,6 }, custom_icons_texture)

	local old_style_marksman_T1 = {"bow_reload_speed_multiplier_1", "bow_concealment_buff"}
	local old_style_marksman_T2 = {"bow_reload_speed_multiplier_2", "bow_extra_ammo_multiplier_1"}
	self:add_new_skill("old_style_marksman", old_style_marksman_T1, old_style_marksman_T2 , 2, { 6,0 }, custom_icons_texture)

	-- Tier 3
	local huntsman_T1 = {"bow_critical_hit_chanche_1"}
	local huntsman_T2 = {"bow_critical_hit_chanche_2"}
	self:add_new_skill("huntsman", huntsman_T1 , huntsman_T2, 3, {7, 0}, custom_icons_texture)

    self:add_new_skill("overcharge", "overcharge_1", "overcharge_2", 3, {4, 2}, custom_icons_texture)
	
	-- Tier 4
    self:add_new_skill("bow_multishot_overload", {"bow_multishot_overload_1"}, {"bow_multishot_overload_2"}, 3, {5, 0}, custom_icons_texture)
end)
